SeExpr

Public Slots | Public Member Functions | Private Slots | Private Attributes | List of all members
ExprBrowser Class Reference

`#include <ExprBrowser.h>`

Inheritance diagram for ExprBrowser:

## Public Slots
void | handleSelection (const QModelIndex &current, const QModelIndex &previous)
void | update ()
void | clear ()
void | clearSelection ()
void | saveExpression ()
void | saveLocalExpressionAs ()
void | saveExpressionAs ()

## Public Member Functions
| ExprBrowser (QWidget *parent, ExprEditor *editor)
| ~ExprBrowser ()
void | addPath (const std::string &name, const std::string &path)
std::string | getSelectedPath ()
void | selectPath (const char *path)
void | addUserExpressionPath (const std::string &context)
bool | getExpressionDirs ()
bool | getExpressionDirs (const std::string &context)
void | setSearchPath (const QString &context, const QString &path)
void | expandAll ()
void | expandToDepth (int depth)
void | setApplyOnSelect (bool on)

## Private Slots
void | clearFilter ()
void | filterChanged (const QString &str)

## Private Attributes
ExprEditor * | editor
QList< QString > | labels
QList< QString > | paths
ExprTreeModel * | treeModel
ExprTreeFilterModel * | proxyModel
QTreeView * | treeNew
QLineEdit * | exprFilter
std::string | _userExprDir
std::string | _localExprDir
std::string | _context
std::string | _searchPath
bool | _applyOnSelect

## Detailed Description

Definition at line 43 of file ExprBrowser.h.

## Constructor & Destructor Documentation

## ◆ ExprBrowser()

ExprBrowser::ExprBrowser | ( | QWidget * | parent,
|  | ExprEditor * | editor
| ) |  |

Definition at line 242 of file ExprBrowser.cpp.

References clearFilter(), exprFilter, filterChanged(), handleSelection(), proxyModel, treeModel, and treeNew.

## ◆ ~ExprBrowser()

ExprBrowser::~ExprBrowser | ( |  | ) |

Definition at line 240 of file ExprBrowser.cpp.

References treeModel.

## Member Function Documentation

## ◆ addPath()

void ExprBrowser::addPath | ( | const std::string & | name,
|  | const std::string & | path
| ) |  |

Definition at line 274 of file ExprBrowser.cpp.

References ExprTreeModel::addPath(), labels, paths, and treeModel.

Referenced by addUserExpressionPath(), and getExpressionDirs().

## ◆ addUserExpressionPath()

void ExprBrowser::addUserExpressionPath | ( | const std::string & | context | ) |

Definition at line 399 of file ExprBrowser.cpp.

References _userExprDir, addPath(), and context.

Referenced by getExpressionDirs().

## ◆ clear

void ExprBrowser::clear | ( |  | ) |
| slot

Definition at line 319 of file ExprBrowser.cpp.

References ExprTreeModel::clear(), clearSelection(), labels, paths, and treeModel.

Referenced by getExpressionDirs().

## ◆ clearFilter

void ExprBrowser::clearFilter | ( |  | ) |
| private slot

Definition at line 329 of file ExprBrowser.cpp.

References exprFilter.

Referenced by ExprBrowser().

## ◆ clearSelection

void ExprBrowser::clearSelection | ( |  | ) |
| slot

Definition at line 327 of file ExprBrowser.cpp.

References treeNew.

Referenced by clear(), and ExprDialog::clearExpression().

## ◆ expandAll()

void ExprBrowser::expandAll | ( |  | ) |

Definition at line 394 of file ExprBrowser.cpp.

References treeNew.

Referenced by ExprDialog::exec(), ExprDialog::show(), and ExprShortEdit::showDetails().

## ◆ expandToDepth()

void ExprBrowser::expandToDepth | ( | int | depth | ) |

Definition at line 396 of file ExprBrowser.cpp.

References treeNew.

## ◆ filterChanged

void ExprBrowser::filterChanged | ( | const QString & | str | ) |
| private slot

Definition at line 331 of file ExprBrowser.cpp.

References proxyModel, and treeNew.

Referenced by ExprBrowser().

## ◆ getExpressionDirs() [1/2]

bool ExprBrowser::getExpressionDirs | ( |  | ) |

Definition at line 415 of file ExprBrowser.cpp.

References _context, _localExprDir, _searchPath, addPath(), addUserExpressionPath(), clear(), context, file(), P3D_CONFIG_ENVVAR, and update().

Referenced by ExprDialog::exec(), and ExprDialog::show().

## ◆ getExpressionDirs() [2/2]

bool ExprBrowser::getExpressionDirs | ( | const std::string & | context | ) |

## ◆ getSelectedPath()

std::string ExprBrowser::getSelectedPath | ( |  | ) |

Definition at line 285 of file ExprBrowser.cpp.

References ExprTreeItem::path, proxyModel, and treeNew.

Referenced by saveExpression().

## ◆ handleSelection

void ExprBrowser::handleSelection | ( | const QModelIndex & | current,
|  | const QModelIndex & | previous
| ) |  |
| slot

Definition at line 305 of file ExprBrowser.cpp.

References _applyOnSelect, editor, file(), ExprTreeItem::path, proxyModel, and ExprEditor::setExpr().

Referenced by ExprBrowser().

## ◆ saveExpression

void ExprBrowser::saveExpression | ( |  | ) |
| slot

Definition at line 377 of file ExprBrowser.cpp.

References editor, file(), ExprEditor::getExpr(), getSelectedPath(), and saveExpressionAs().

## ◆ saveExpressionAs

void ExprBrowser::saveExpressionAs | ( |  | ) |
| slot

Definition at line 341 of file ExprBrowser.cpp.

References _userExprDir, editor, file(), ExprEditor::getExpr(), selectPath(), and update().

Referenced by saveExpression().

## ◆ saveLocalExpressionAs

void ExprBrowser::saveLocalExpressionAs | ( |  | ) |
| slot

Definition at line 359 of file ExprBrowser.cpp.

References _localExprDir, editor, file(), ExprEditor::getExpr(), selectPath(), and update().

## ◆ selectPath()

void ExprBrowser::selectPath | ( | const char * | path | ) |

Definition at line 295 of file ExprBrowser.cpp.

References ExprTreeModel::find(), index(), proxyModel, treeModel, and treeNew.

Referenced by saveExpressionAs(), and saveLocalExpressionAs().

## ◆ setApplyOnSelect()

void ExprBrowser::setApplyOnSelect | ( | bool | on | ) |
| inline

Definition at line 71 of file ExprBrowser.h.

References _applyOnSelect.

Referenced by ExprShortEdit::showDetails().

## ◆ setSearchPath()

void ExprBrowser::setSearchPath | ( | const QString & | context,
|  | const QString & | path
| ) |  |

Definition at line 280 of file ExprBrowser.cpp.

References _context, _searchPath, and context.

Referenced by ExprShortEdit::showDetails().

## ◆ update

void ExprBrowser::update | ( |  | ) |
| slot

Definition at line 300 of file ExprBrowser.cpp.

References proxyModel, treeModel, ExprTreeModel::update(), and ExprTreeFilterModel::update().

Referenced by getExpressionDirs(), saveExpressionAs(), and saveLocalExpressionAs().

## Member Data Documentation

## ◆ _applyOnSelect

bool ExprBrowser::_applyOnSelect
| private

Definition at line 57 of file ExprBrowser.h.

Referenced by handleSelection(), and setApplyOnSelect().

## ◆ _context

std::string ExprBrowser::_context
| private

Definition at line 55 of file ExprBrowser.h.

Referenced by getExpressionDirs(), and setSearchPath().

## ◆ _localExprDir

std::string ExprBrowser::_localExprDir
| private

Definition at line 54 of file ExprBrowser.h.

Referenced by getExpressionDirs(), and saveLocalExpressionAs().

## ◆ _searchPath

std::string ExprBrowser::_searchPath
| private

Definition at line 56 of file ExprBrowser.h.

Referenced by getExpressionDirs(), and setSearchPath().

## ◆ _userExprDir

std::string ExprBrowser::_userExprDir
| private

Definition at line 53 of file ExprBrowser.h.

Referenced by addUserExpressionPath(), and saveExpressionAs().

## ◆ editor

ExprEditor* ExprBrowser::editor
| private

Definition at line 46 of file ExprBrowser.h.

Referenced by handleSelection(), saveExpression(), saveExpressionAs(), and saveLocalExpressionAs().

## ◆ exprFilter

QLineEdit* ExprBrowser::exprFilter
| private

Definition at line 52 of file ExprBrowser.h.

Referenced by clearFilter(), and ExprBrowser().

## ◆ labels

QList<QString> ExprBrowser::labels
| private

Definition at line 47 of file ExprBrowser.h.

Referenced by addPath(), and clear().

## ◆ paths

QList<QString> ExprBrowser::paths
| private

Definition at line 48 of file ExprBrowser.h.

Referenced by addPath(), and clear().

## ◆ proxyModel

ExprTreeFilterModel* ExprBrowser::proxyModel
| private

Definition at line 50 of file ExprBrowser.h.

Referenced by ExprBrowser(), filterChanged(), getSelectedPath(), handleSelection(), selectPath(), and update().

## ◆ treeModel

ExprTreeModel* ExprBrowser::treeModel
| private

Definition at line 49 of file ExprBrowser.h.

Referenced by addPath(), clear(), ExprBrowser(), selectPath(), update(), and ~ExprBrowser().

## ◆ treeNew

QTreeView* ExprBrowser::treeNew
| private

Definition at line 51 of file ExprBrowser.h.

Referenced by clearSelection(), expandAll(), expandToDepth(), ExprBrowser(), filterChanged(), getSelectedPath(), and selectPath().

The documentation for this class was generated from the following files:

- /build/seexpr/src/SeExpr/src/SeExpr2/UI/ExprBrowser.h
- /build/seexpr/src/SeExpr/src/SeExpr2/UI/ExprBrowser.cpp